"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DuplicateCueStepError = exports.InvalidCueStepError = exports.GroupStepsCompleteError = exports.UnregisteredGroupError = void 0;
class UnregisteredGroupError extends Error {
    constructor(groupId) {
        super(`Group ${groupId} not registered.`);
        this.name = 'UnregisteredGroup';
    }
}
exports.UnregisteredGroupError = UnregisteredGroupError;
class GroupStepsCompleteError extends Error {
    constructor(groupId, steps) {
        super(`Group ${groupId} has already ${steps} step(s). Can not add another one.`);
        this.name = 'GroupStepsComplete';
    }
}
exports.GroupStepsCompleteError = GroupStepsCompleteError;
class InvalidCueStepError extends Error {
    constructor(groupId, steps, step) {
        super(`Group ${groupId} has only ${steps} steps. Can not add another with step:${step}.`);
        this.name = 'InvalidCueStep';
    }
}
exports.InvalidCueStepError = InvalidCueStepError;
class DuplicateCueStepError extends Error {
    constructor(groupId, step) {
        super(`Group ${groupId} already has Cue with step ${step} registered.`);
        this.name = 'DuplicateCueStep';
    }
}
exports.DuplicateCueStepError = DuplicateCueStepError;
//# sourceMappingURL=guide-cue-exceptions.js.map