import React from 'react';
import { useHotkeys as useGlobalHotkeys } from 'react-hotkeys-hook';
type GlobalHotkeysArgs = Parameters<typeof useGlobalHotkeys>;
/**
 *
 * The modifier keys are interpreted differently on macOS and Windows/Linux.
 * useGlobalHotkeys hook normalizes the modifier keys so that they are interpreted on both platforms as follows:
 *
 * Modifier | macOS     | Windows | Linux
 * -------- | --------- | ------- | -------
 * ctrl     | control   | ctrl    | ctrl
 * shift    | shift     | shift   | shift
 * alt      | option    | alt     | alt
 * meta     | command   | windows | meta
 * mod      | command   | ctrl    | ctrl
 *
 */
export declare const useHotkeys: (key: string, callback: GlobalHotkeysArgs[1], options?: GlobalHotkeysArgs[2], deps?: GlobalHotkeysArgs[3]) => React.MutableRefObject<import("react-hotkeys-hook/dist/types").RefType<HTMLElement>>;
export declare const formatHotkey: (key: string) => string;
export declare const KeyboardShortcut: ({ hotkey }: {
    hotkey: string;
}) => React.JSX.Element;
export {};
//# sourceMappingURL=use-hotkeys.d.ts.map